<?php
/*
 *  This file is part of The NWA Toolset.
 *
 *  Copyright (C) 2001-2002 Royal Library in Stockholm,
 *                          Royal Library in Copenhagen,
 *                          Helsinki University Library of Finland, 
 *                          National Library of Norway,
 *                          National and University Library of Iceland.
 *
 *  The NWA Toolset is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The NWA Toolset is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The NWA Toolset; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
* File: config.inc.template
* 
* $Id: config.inc,v 1.2 2004/07/04 21:22:02 sverreb Exp $
*
* This is the template file for the config.inc file which is included first in all .php files.
* Copy this file to config.inc
*
*/

// Path to includefiles
$conf_rootpath = "/srv/www/htdocs/nwatoolset";
$conf_includepath = "$conf_rootpath/gui/php_includes";
$conf_searchenginepath = "$conf_includepath/seal";

// What search engine driver to use
$conf_index_path = "$conf_searchenginepath/fast";
$conf_index_file = "$conf_index_path/dummy.inc";
$conf_index_class = fastSearch;

// Prefix to document retriever
$document_retriever = "http://fast2.nb.no:16000/webarkiv/retriever_nedlib_2.php";
$conf_document_retriever = "$document_retriever?reqtype=getfile&aid=";

// URL of gui installation
$conf_http_host = "http://localhost/nwatoolset/gui";

// URL to resultpage
$conf_result_page = "$conf_http_host/result.php";
$conf_document_dispatcher = "$conf_http_host/documentDispatcher.php";

// Location of resultlist.inc
$conf_result_list = "$conf_includepath/resultlist.inc";

// URL of search interfaces
$conf_simple_search = "$conf_http_host/search.php";
$conf_advanced_search = "$conf_http_host/asearch.php";

// Dummy image to display when not archived
$conf_defaultimage = "$conf_rootpath/html/nwa_notavail.gif";

// Mapping of MIME-types to document handler url's. The extra parameter indicates if this document-handler rewrites links or not.
$conf_document_handler = array(
             "text/html" => "$conf_http_host/test.html nolinks",
             //"text/html" => "http://fast2.nb.no:16000/cgi-bin/htmlhandler.pl parselinks",
             
             "image" => "http://fast2.nb.no:16000/nwatoolset/handlers/passthrough.php nolinks",
             "default" => "http://fast2.nb.no:16000/nwatoolset/handlers/passthrough.php nolinks");

// Site information
// Location of this site
$conf_location_code = "no paradigma";

// Mapping from collections to URLs
$conf_locations['no'] = "$conf_http_host/result.php";

// JavaScript disable/enabled for archived pages viewed in Archive Document View
// values can be "on" or "off"
$conf_javascript = "off";  

//Help file links
$conf_helplinks['search'] = array("name" =>'Help',
                                  "file" =>'help.php');

// Initialize
include_once("$conf_includepath/init.inc");
?>
