<?php

/*
 *  This file is part of The NWA Toolset.
 *
 *  Copyright (C) 2001-2004 Royal Library in Stockholm,
 *                          Royal Library in Copenhagen,
 *                          Helsinki University Library of Finland,
 *                          National Library of Norway,
 *                          National and University Library of Iceland.
 *
 *  The NWA Toolset is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The NWA Toolset is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The NWA Toolset; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 * File: asearch.php
 *
 * $Id: searchresult.inc,v 1.3 2004/10/04 09:05:24 johnerik Exp $
*/


  $search = new $conf_index_class();

  $resultlist = new resultList($search, $querystring, $start, $sizeofresultset, $sortorder, $fields);
  $total = $resultlist->getNumVersions();
  
  if ($debug == 1) {
    print $querystring . "<br>&nbsp<br>";
  }

  if ($total > 0) {
    $results = $resultlist->getResultSet();
    print "<!--";
    print_r ($results);
    print "-->";
    $last_hit = $results['hits_in_set'] + $start - 1;
    print(nls("Total number of versions found") . " : <b>$total</b>. ");
    print(nls("Displaying web pages"));
    print " <b>$start-$last_hit";
    print "</td></tr>";
    print "<tr><td class=\"norm\">";
    for ($i = $start; $i <= $last_hit; $i++) {
      print "<b>" . $i . ". " . $results[$i]['teaser'] . "</b> ";
      print "(" . $results[$i]['url'] . ")<br>";
      print nls("Number of versions satisfying query") . " / " . nls("total number of versions") . " : ";
      $numversions = $results[$i][numversions];
      print $results[$i][numversions] . "/" . $results[$i][totalversions] . "<br>";
      $linkstring = "<a href=\"result.php?time=" . $results[$i][versions][1]['archival_time'] . "&url=" . index_encode($results[$i]["url"]) . "\">" . nls("Timeline") . "</a>";
      $overview = "<a href=\"overview.php?url=" . index_encode($results[$i]["url"]) . "\" >" . nls("Overview") . "</a>";
      print "<b>" . $linkstring . " | " . $overview ."</b>";
      print "<br>&nbsp;<br>";
    }
    $next_start = $start + $sizeofresultset;


    print "<b>Results: ";


    if ($start > 1) {
      $prev_start = $start - $sizeofresultset;
      print "  <a href=\"" . $_SERVER['PHP_SELF'] . "?querytype=" . $querytype . "&query=" . urlencode($query) . "&time_search=" . $time_search . "&start=" . $prev_start . " \">&lt;&lt; " . nls("Prev") . "</a> | ";
    }

    for ($i = 1 ; ; $i++) {
      $high_lim = $i * $sizeofresultset;
      $low_lim = $high_lim +1 - $sizeofresultset;

      if ($high_lim >= $last_hit) {
        if ($start == $low_lim) {
          print $low_lim . "-" . $last_hit . " | ";
        }
        else {
          print "  <a href=\"" . $_SERVER['PHP_SELF'] . "?querytype=" . $querytype . "&query=" . urlencode($query) . "&time_search=" . $time_search . "&start=" . $low_lim . " \">" . $low_lim . "-" . $last_hit . "</a> | ";
        }
        break;
      }
      else {
        if ($start == $low_lim) {
          print $low_lim . "-" . $high_lim . " | ";
        }
        else {
          print "  <a href=\"" . $_SERVER['PHP_SELF'] . "?querytype=" . $querytype . "&query=" . urlencode($query) . "&time_search=" . $time_search . "&start=" . $low_lim . " \">" . $low_lim . "-" . $high_lim . "</a> | ";
        }
      }
    }


    if ($resultlist->link_to_next) {
      print "  <a href=\"" . $_SERVER['PHP_SELF'] . "?querytype=" . $querytype . "&query=" . urlencode($query) . "&time_search=" . $time_search . "&start=" . $next_start . "\">" . nls("Next") . " &gt;&gt;</a>";
    }


  }
  else {
    print "No hits!";
  }

?>
