#!/usr/local/bin/perl 
 ##
 ##  This file is part of The NWA Toolset.
 ##
 ##  Copyright (C) 2001-2004 Royal Library in Stockholm,
 ##                          Royal Library in Copenhagen,
 ##                          Helsinki University Library of Finland,
 ##                          National Library of Norway,
 ##                          National and University Library of Iceland.
 ##
 ##  The NWA Toolset is free software; you can redistribute it and/or modify
 ##  it under the terms of the GNU General Public License as published by
 ##  the Free Software Foundation; either version 2 of the License, or
 ##  (at your option) any later version.
 ##
 ##  The NWA Toolset is distributed in the hope that it will be useful,
 ##  but WITHOUT ANY WARRANTY; without even the implied warranty of
 ##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ##  GNU General Public License for more details.
 ##
 ##  You should have received a copy of the GNU General Public License
 ##  along with The NWA Toolset; if not, write to the Free Software
 ##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ##

 ## $Id: retriever_test.pl,v 1.1 2004/04/30 16:28:03 svc Exp $

 ## Function: A CGI-script, that takes an AID and shows the object in the browser
 ##           Is a wrapper around the File/Document Retriever


## Need to set the RETRIEVER in this script
## Later on maybe integrate it 

$retriever = "RETRIEVER";
#$retriever = "http://asterix.kb.dk/nwatoolset/arc_retriever.pl";

use LWP::Simple;
use XML::Simple;
use CGI;
use Data::Dumper;

my $query = new CGI;
if ($retriever eq "RETRIEVER"){
    &error_html("You need to set the variable \$retriever before using this script");
    print STDERR "You need to set the variable \$retriever before using this script";
    exit;
}

my $archive_id = $query->param('aid');
if (!defined($archive_id)) {
    &error_html("Argument 'aid' missing");
    exit;
}

my $meta_url = "$retriever?aid=$archive_id&reqtype=getmeta";
my $file_url = "$retriever?aid=$archive_id&reqtype=getfile";
my $metadata = get($meta_url);
my $file_content = get($file_url);

### Extract http-header from $metadata

my $result_hash = XMLin($metadata, suppressempty => "");

## Examine 'head' tag of the retrievermessage
## Find out whether or not this is an error-message: It is an error-message
## If the message contains an head/errorcode xmltag

if (exists($result_hash->{head}->{errorcode})) {
        ### error ####
        my $errorcode = $result_hash->{head}->{errorcode};
        my $errormessage = $result_hash->{head}->{errormessage};
        my $result_string = "Request returned errorcode: ";
        $result_string .= "\'$errorcode\', and errormessage:\'$errormessage\'";
        &error_html($result_string);
	exit;
}

## post-condition: The message is not an error-message

if (0) {
if (exists($result_hash->{body}->{metadata}->{'http-header'}))
{
    ### print http-header to STDOUT
    print $result_hash->{body}->{metadata}->{'http-header'};
}

}
my $content_type = undef;
my $encoding = undef;

if (exists($result_hash->{body}->{metadata}->{contenttype}->{type})) {
    $content_type = $result_hash->{body}->{metadata}->{contenttype}->{type};
}else {
    &error_html("retrievermessage/body/metadata/contenttype/type not returned by retriever");
    exit;
}

if (exists($result_hash->{body}->{metadata}->{contenttype}->{charset})) {

    $encoding = $result_hash->{body}->{metadata}->{contenttype}->{charset};
}else {
    &error_html("retrievermessage/body/metadata/contenttype/charset not returned by retriever");
    exit;
}

print $query->header("$content_type;$encoding");
##print "\n\n"; ## separation between http-header and the contents itself
print $file_content;

exit;

sub error_html($) {
    my ($error_string) = @_;
    print $query->header("text/html");
    print "<html>\n";
    print "<HEAD><title>ERROR: $error_string</title></HEAD>\n";
    print "<body><h2>$error_string</h2></body></html>\n";
    return;
}
